package rmsdemowithlistener;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;

public class recListen extends MIDlet implements CommandListener  {

    TextBox textBox = new TextBox ("PALs", "", 150, TextField.ANY);
    int currentId = 1;
    RecordStore pals;
    String listenerMessage = new String("");

    Display display;

    static final Command prevCommand = new Command ("Prev", Command.SCREEN, 1);
    static final Command nextCommand = new Command ("Next", Command.SCREEN, 2);
    static final Command newCommand = new Command ("New", Command.SCREEN, 3);


    public recListen () {
        try {
            pals = RecordStore.openRecordStore ("pals", true);
            pals.addRecordListener(new recordStoreListener());
            String text = loadEntry (pals.getNumRecords());
            textBox.setString (text);
            textBox.setTitle ("PAL DATA " + currentId);
        }
        catch (RecordStoreException e) {
            throw new RuntimeException ("Cannot open pal data; reason: "+e);
        }

        textBox.addCommand (prevCommand);
        textBox.addCommand (nextCommand);
        textBox.addCommand (newCommand);
        textBox.setCommandListener (this);
    }

    public String loadEntry (int newId) throws RecordStoreException {
        if (newId < 1 || newId > pals.getNumRecords ()) {
            byte [] data = " ".getBytes ();
            currentId = pals.addRecord (data, 0, data.length);
        }
        else
            currentId = newId;

        return new String (pals.getRecord (currentId)).trim ();
    }


    public void saveEntry (String entry) throws RecordStoreException {
        byte [] data = (entry + " ").getBytes ();
        pals.setRecord (currentId, data, 0, data.length);
    }

    public void startApp () {
        display = Display.getDisplay (this);
        display.setCurrent (textBox);
    }

    public void destroyApp (boolean unconditional) {
        try {
            String text;
            text = textBox.getString ();
            saveEntry (text);
            pals.closeRecordStore ();
        }
        catch (RecordStoreException e) {
            throw new RuntimeException ("Cannot close pal data; reason: "+e);
        }
    }

    public void pauseApp () {
    }

    public void commandAction (Command c, Displayable d) {
        try {
            saveEntry (textBox.getString ());

            if (c == nextCommand && currentId < pals.getNumRecords ()) {
                textBox.setString (loadEntry (currentId+1));
            }
            else if (c == prevCommand && currentId > 1) {
                textBox.setString (loadEntry (currentId-1));
            }
            else if (c == newCommand) {
                textBox.setString (loadEntry (pals.getNumRecords () + 1));
            }


            textBox.setTitle ("PAL DATA " + currentId);

        }
        catch (RecordStoreException e) {
            throw new RuntimeException ("Cannot perform; reason: "+e);
        }
    }

    public class recordStoreListener implements RecordListener {
      public void recordAdded(RecordStore rs, int id) {
        displayRecordListenerAlert("Added", rs, id);
      };
      public void recordChanged(RecordStore rs, int id) {
        displayRecordListenerAlert("Updated", rs, id);
      };
      public void recordDeleted(RecordStore rs, int id) {
      };
    }

    public void displayRecordListenerAlert(String operation, RecordStore rs, int id) {
      Alert alert = null;

      listenerMessage = " " + "Successfully" + " " + operation + " Record #" + id;
      try{
        alert = new Alert(rs.getName() + " ver " + rs.getVersion(),
                          listenerMessage, null, AlertType.CONFIRMATION);
      } catch(RecordStoreException e) {
        e.printStackTrace();
      }

      Display.getDisplay(this).setCurrent(alert);
    }
}

